using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Threading;

namespace BarrierDemo
{
    class Program
    {
        const int ileZadan = 10;
        static Barrier b = new Barrier(ileZadan, (Barrier _b) => { Console.WriteLine(); });

        static void Main(string[] args)
        {
            Action metodaWatku = 
                () => 
                {
                    for (int i = 0; i < 10; ++i)
                    {
                        Console.Write(i.ToString());
                        b.SignalAndWait();
                    }
                };
            Task[] zadania = new Task[ileZadan];
            for (int i = 0; i < ileZadan; ++i) 
            {
                zadania[i] = new Task(metodaWatku);
                zadania[i].Start();
            }

            //zadania[0].Wait(); Console.WriteLine("Zadanie 0 zakończyło działanie");
            
            //for (int i = 0; i < ileZadan; ++i) zadania[i].Wait();
            //Task.WaitAll(zadania);
            //Console.WriteLine("Wszystkie zadania zakończyły działanie");

            Console.ReadLine();
        }
    }
}
